import { ICache } from "miniprogram-cache";
import { IDataFetcher } from "./IDataFetcher";
import { ISubscription } from "./ISubscription";
import { IPostFetchHandler } from "./IPostFetchHandler";
export declare class DataProvider<T> {
    private static readonly _prefix;
    private readonly _fetcher;
    private readonly _fetchRetention;
    private readonly _postFetch;
    private readonly _cache?;
    private readonly _cacheKey;
    private readonly _subscriptions;
    private _lastFetched;
    private _loadedFromCache;
    private _data?;
    private _fetching;
    private _fetchPromise?;
    constructor(initialValue: T | undefined, fetcher: IDataFetcher<T>, fetchRetention: number | undefined, postFetch: IPostFetchHandler<T> | undefined, cache: ICache | undefined, cacheKey: string | undefined);
    subscribe(subscription: ISubscription<T>): number;
    unsubscribe(handle: number): void;
    getLocal(triggerFetch?: boolean): Promise<T | undefined>;
    setLocal(data: T): Promise<void>;
    fetchRemote(): Promise<T | undefined>;
    private innerFetchRemote;
    private loadData;
    private invokeDataChanged;
    private fireDataChangedEvent;
    private invokeFetching;
    private fireFetchingEvent;
    private invokeFetched;
    private fireFetchedEvent;
    private invokeFetchError;
    private fireFetchErrorEvent;
}
