"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var DataProvider = /** @class */ (function () {
    function DataProvider(initialValue, fetcher, fetchRetention, postFetch, cache, cacheKey) {
        if (fetchRetention === void 0) { fetchRetention = 0; }
        this._fetchRetention = 0;
        this._postFetch = undefined;
        this._cache = undefined;
        this._cacheKey = "";
        this._subscriptions = new Array();
        this._lastFetched = 0;
        this._loadedFromCache = false;
        this._data = undefined;
        // private _dataLoaded: boolean = false;
        this._fetching = false;
        this._fetchPromise = undefined;
        this._data = initialValue;
        this._fetcher = fetcher;
        this._fetchRetention = fetchRetention > 0 ? fetchRetention : 0;
        this._postFetch = postFetch;
        if (cache) {
            this._cache = cache;
            if (!cacheKey) {
                throw new Error("invalid cacheKey");
            }
            else {
                this._cacheKey = DataProvider._prefix + cacheKey;
            }
        }
    }
    DataProvider.prototype.subscribe = function (subscription) {
        var handle = this._subscriptions.push(subscription) - 1;
        if (this._data === undefined) {
            this.loadData();
        }
        else {
            this.invokeDataChanged(subscription);
        }
        return handle;
    };
    DataProvider.prototype.unsubscribe = function (handle) {
        if (handle < 0 || handle >= this._subscriptions.length) {
            throw new Error("index out of bound " + handle + "/" + this._subscriptions.length);
        }
        this._subscriptions[handle] = undefined;
    };
    DataProvider.prototype.getLocal = function (triggerFetch) {
        if (triggerFetch === void 0) { triggerFetch = true; }
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (triggerFetch) {
                            this.fetchRemote();
                        }
                        if (!(this._cache !== undefined && !this._loadedFromCache)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this._cache.get(this._cacheKey)];
                    case 1:
                        data = _a.sent();
                        this._loadedFromCache = true;
                        this._data = data;
                        this.fireDataChangedEvent(data);
                        _a.label = 2;
                    case 2: return [2 /*return*/, this._data];
                }
            });
        });
    };
    DataProvider.prototype.setLocal = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this._data = data;
                        if (!this._cache) return [3 /*break*/, 2];
                        return [4 /*yield*/, this._cache.set(this._cacheKey, data)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        this.fireDataChangedEvent(data);
                        return [2 /*return*/];
                }
            });
        });
    };
    DataProvider.prototype.fetchRemote = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (Date.now() - this._lastFetched < this._fetchRetention) {
                    return [2 /*return*/, this._data];
                }
                if (this._fetching && this._fetchPromise) {
                    return [2 /*return*/, this._fetchPromise];
                }
                this._fetchPromise = this.innerFetchRemote();
                return [2 /*return*/, this._fetchPromise];
            });
        });
    };
    DataProvider.prototype.innerFetchRemote = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 6, , 7]);
                        this._fetching = true;
                        // fire onFetching
                        this.fireFetchingEvent();
                        return [4 /*yield*/, this._fetcher()];
                    case 1:
                        data = _a.sent();
                        this._lastFetched = Date.now();
                        this._fetching = false;
                        if (!this._postFetch) return [3 /*break*/, 3];
                        return [4 /*yield*/, this._postFetch(this._data, data)];
                    case 2:
                        data = _a.sent();
                        _a.label = 3;
                    case 3:
                        this._data = data;
                        if (!(this._cache !== undefined)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this._cache.set(this._cacheKey, this._data)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        this.fireFetchedEvent();
                        return [2 /*return*/, this._data];
                    case 6:
                        err_1 = _a.sent();
                        this._fetching = false;
                        this.fireFetchErrorEvent(err_1);
                        throw err_1;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    DataProvider.prototype.loadData = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this._cache !== undefined && !this._loadedFromCache)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this._cache.get(this._cacheKey)];
                    case 1:
                        data = _a.sent();
                        this._loadedFromCache = true;
                        if (!(data !== undefined)) return [3 /*break*/, 2];
                        this.fireDataChangedEvent(data);
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.fetchRemote()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, this.fetchRemote()];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    DataProvider.prototype.invokeDataChanged = function (sub) {
        if (this._data === undefined) {
            return;
        }
        else {
            try {
                sub.dataHandler && sub.dataHandler(this._data);
            }
            catch (err) {
                sub.onError && sub.onError(err);
            }
        }
    };
    DataProvider.prototype.fireDataChangedEvent = function (data) {
        var _this = this;
        if (data === undefined) {
            return;
        }
        else {
            this._data = data;
            this._subscriptions.forEach(function (sub) {
                sub && _this.invokeDataChanged(sub);
            });
        }
    };
    DataProvider.prototype.invokeFetching = function (sub) {
        try {
            sub.onFetching && sub.onFetching();
        }
        catch (err) {
            sub.onError && sub.onError(err);
        }
    };
    DataProvider.prototype.fireFetchingEvent = function () {
        var _this = this;
        this._subscriptions.forEach(function (sub) {
            sub && _this.invokeFetching(sub);
        });
    };
    DataProvider.prototype.invokeFetched = function (sub) {
        if (this._data === undefined) {
            return;
        }
        try {
            sub.onFetched && sub.onFetched(this._data);
        }
        catch (err) {
            sub.onError && sub.onError(err);
        }
    };
    DataProvider.prototype.fireFetchedEvent = function () {
        var _this = this;
        this._subscriptions.forEach(function (sub) {
            if (!sub) {
                return;
            }
            if (sub.onFetched) {
                _this.invokeFetched(sub);
            }
            else {
                _this.invokeDataChanged(sub);
            }
        });
    };
    DataProvider.prototype.invokeFetchError = function (sub, err) {
        try {
            sub.onFetchError && sub.onFetchError(err);
        }
        catch (_a) { }
    };
    DataProvider.prototype.fireFetchErrorEvent = function (err) {
        var _this = this;
        this._subscriptions.forEach(function (sub) {
            sub && _this.invokeFetchError(sub, err);
        });
    };
    DataProvider._prefix = "$data:";
    return DataProvider;
}());
exports.DataProvider = DataProvider;
//# sourceMappingURL=DataProvider.js.map