import { ICache } from "miniprogram-cache";
import { DataProvider } from "./DataProvider";
import { IDataFetcher } from "./IDataFetcher";
import { IPostFetchHandler } from "./IPostFetchHandler";
export declare class DataProviderBuilder<T> {
    private _initialValue;
    private _fetcher;
    private _fetchRetention;
    private _cache;
    private _cacheKey;
    private _postFetch;
    constructor(fetcher: IDataFetcher<T>);
    setInitialValue(f: () => T): DataProviderBuilder<T>;
    setFetchRetention(retention: number): DataProviderBuilder<T>;
    useCache(cache: ICache, cacheKey: string): DataProviderBuilder<T>;
    usePostFetch(f: IPostFetchHandler<T>): DataProviderBuilder<T>;
    build(): DataProvider<T>;
}
